config/routes.rb
Blog::Application.routes.draw do
  resources :articles
  root to: 'articles#index'
  match 'auth/:provider/callback', to: 'sessions#create'
  match 'auth/failure', to: redirect('/')
  match 'signout', to: 'sessions#destroy', as: 'signout'
end

app/models/article.rb
class Article < ActiveRecord::Base
  attr_accessible :author, :content, :name, :published_at
end

app/models/user.rb
class User < ActiveRecord::Base
  def self.from_omniauth(auth)
    where(auth.slice("provider", "uid")).first || create_from_omniauth(auth)
  end
  
  def self.create_from_omniauth(auth)
    create! do |user|
      user.provider = auth["provider"]
      user.uid = auth["uid"]
      user.name = auth["info"]["name"]
    end
  end
end

app/controllers/application_controller.rb
class ApplicationController < ActionController::Base
  protect_from_forgery
  
private

  def current_user
    @current_user ||= User.find(session[:user_id]) if session[:user_id]
  end
  helper_method :current_user
end

app/controllers/articles_controller.rb
class ArticlesController < ApplicationController
  def index
    @articles = Article.order("published_at desc")
  end

  def show
    @article = Article.find(params[:id])
  end
end

app/controllers/sessions_controller.rb
class SessionsController < ApplicationController
  def create
    user = User.from_omniauth(env["omniauth.auth"])
    session[:user_id] = user.id
    redirect_to root_url, notice: "Signed in!"
  end
  
  def destroy
    session[:user_id] = nil
    redirect_to root_url, notice: "Signed out!"
  end
end

app/helpers/application_helper.rb
module ApplicationHelper
end

app/helpers/articles_helper.rb
module ArticlesHelper
end

app/views/articles/index.html.erb
<h1>Articles</h1>

<div id="articles">
<% @articles.each do |article| %>
  <h2><%= link_to article.name, article %></h2>
  <div class="info">
    by <%= article.author %>
    on <%= article.published_at.strftime('%b %d, %Y') %>
  </div>
  <div class="content"><%= article.content %></div>
<% end %>
</div>

app/views/articles/show.html.erb
<h1><%= @article.name %></h1>

<p class="info">by <%= @article.author %> on <%= @article.published_at.strftime('%b %d, %Y') %></p>

<%= simple_format @article.content %>

<p><%= link_to "Back to Articles", articles_path %></p>

app/views/layouts/application.html.erb
<!DOCTYPE html>
<html>
  <head>
    <title>Blog</title>
    <%= stylesheet_link_tag    "application", media: "all" %>
    <%= javascript_include_tag "application" %>
    <%= csrf_meta_tag %>
  </head>
  <body>
    <div id="container">
      <div id="user_nav">
        <% if current_user %>
          Signed in as <%= current_user.name %>!
          <%= link_to "Sign out", signout_path %>
        <% else %>
          <%= link_to "Sign in with Twitter", "/auth/twitter" %>
          <%= link_to "Sign in with Google", "/auth/google_oauth2" %>
          <%= link_to "Sign in with OpenID", "/auth/open_id" %>
        <% end %>
      </div>
      <% flash.each do |name, msg| %>
        <%= content_tag :div, msg, id: "flash_#{name}" %>
      <% end %>
      <%= yield %>
    </div>
  </body>
</html>